local SERP_LAUGH = {sfx_srplg1, sfx_srplg2, sfx_srplg3}

local SERP_LAUGH2 = {sfx_srplg1, sfx_none, sfx_srplg2, sfx_none, sfx_srplg3}

local SERP_ROCKET = {sfx_none, sfx_srp22, sfx_none}

local SERP_HIT = {sfx_srpht1, sfx_srpht2}

addHook("ThinkFrame", do
	for player in players.iterate
		if (player.mo and player.mo.valid and player.mo.skin == "serpentine")
		and (P_IsObjectOnGround(player.mo))
			player.target = P_LookForEnemies(player, false, true)
			if player.target
				P_SpawnLockOn(player, player.target, S_LOCKON3)
			end
		end
		if (player.mo and player.mo.valid and player.mo.skin == "serpentine")
			player.powers[pw_underwater] = 99999*TICRATE
			if not (player.mo.serp_hit)
				player.mo.serp_hit = 0
			end
			if P_PlayerInPain(player)
			and player.mo.serp_hit == 0
				//Check a painsound
				if not S_SoundPlaying(player.mo,sfx_altow1)
				or not S_SoundPlaying(player.mo,sfx_altow2)
				or not S_SoundPlaying(player.mo,sfx_altow3)
				or not S_SoundPlaying(player.mo,sfx_altow4)
				or not S_SoundPlaying(player.mo,sfx_altow5)
				or not S_SoundPlaying(player.mo,sfx_altow6)
				or not S_SoundPlaying(player.mo,sfx_altow7)
				or not S_SoundPlaying(player.mo,sfx_altow8)
					//pain sound
					S_StartSound(player.mo, SERP_HIT[P_RandomRange(1, #SERP_HIT)])
					player.mo.serp_hit = 1
				end
				//Ending painsound
			end
			if not P_PlayerInPain(player)
				player.mo.serp_hit = 0
			end
			if not (player.mo.serpantine_laugh)
				player.mo.serpantine_laugh = false
			end
			if player.mo.state == S_PLAY_WAIT
				if player.mo.serpantine_laugh == false
					S_StartSound(player.mo, SERP_LAUGH[P_RandomRange(1, #SERP_LAUGH)])
					player.mo.serpantine_laugh = true
				else
					if not S_SoundPlaying(player.mo, sfx_srplg1)
					and not S_SoundPlaying(player.mo, sfx_srplg2)
					and not S_SoundPlaying(player.mo, sfx_srplg3)
						player.mo.state = S_PLAY_STND
						player.mo.serpantine_laugh = false
					end
				end
			else
				if player.mo.serpantine_laugh == true
					player.mo.serpantine_laugh = false
				end
			end
			if not (player.mo.local_usedown1)
				player.mo.local_usedown1 = 0
			end
			if not (player.mo.local_usedown2)
				player.mo.local_usedown2 = 0
			end
			if not (player.cmd.buttons & BT_USE)
				player.mo.local_usedown1 = 0
				player.mo.local_usedown2 = 0
			end
			if not (player.mo.serpentine_rocket)
				player.mo.serpentine_rocket = 0
			end
			if player.mo.serpentine_rocket > 0
				player.mo.serpentine_rocket = $1 - 1
			end
			if player.mo.serpentine_rocket > 1
				player.mo.custom2down = 1
			end
			if not (player.mo.serpentinedash)
				player.mo.serpentinedash = 0
			end
			if player.mo.serpentinedash > 0
				player.mo.serpentinedash = $1 - 1
			end
			if not (player.mo.serpentine_fire)
				player.mo.serpentine_fire = 0
			end
			if player.mo.serpentine_fire > 0
				player.mo.serpentine_fire = $1 - 1
			end
			if not (player.mo.serpentine_fire2)
				player.mo.serpentine_fire2 = 0
			end
			if player.mo.serpentine_fire2 > 0
				player.mo.serpentine_fire2 = $1 - 1
			end
			if not (player.mo.serpentine_fire3)
				player.mo.serpentine_fire3 = 0
			end
			if player.mo.serpentine_fire3 > 0
				player.mo.serpentine_fire3 = $1 - 1
			end
			if not (player.mo.serpentinebattle_cooldown)
				player.mo.serpentinebattle_cooldown = 0
			end
			if player.mo.serpentinebattle_cooldown > 0
				player.mo.serpentinebattle_cooldown = $1 - 1
			end
			if player.mo.state == S_PLAY_DASHRUN_SERPENTINE
				local serpentinedash = P_SpawnGhostMobj(player.mo)
				serpentinedash.color = SKINCOLOR_LIME
				serpentinedash.colorized = true
				serpentinedash.blendmode = AST_ADD
				serpentinedash.target = player.mo
				serpentinedash.fuse = 6
				serpentinedash.destscale = 0
				player.mo.local_usedown2 = 1
			end
			if player.mo.state == S_PLAY_SERPENTINE_DASH3
				player.mo.state = S_PLAY_DASHRUN_SERPENTINE
				S_StartSound(player.mo, sfx_zoom)
				if (player.mo.eflags & MFE_UNDERWATER)
					P_InstaThrust(player.mo, player.mo.angle, 50*FRACUNIT/2)
				else
					P_InstaThrust(player.mo, player.mo.angle, 50*FRACUNIT)
				end
				player.mo.serpentinedash = 1*TICRATE
			end
			if player.mo.state == S_PLAY_SERPENTINE_DASH1
			or player.mo.state == S_PLAY_SERPENTINE_DASH2
			or player.mo.state == S_PLAY_SERPENTINE_DASH3
				player.mo.momx = 8*$/9
				player.mo.momy = 8*$/9
			end
			if player.mo.serpentinedash > 1
				local serpentinedash = P_SpawnGhostMobj(player.mo)
				serpentinedash.color = SKINCOLOR_YELLOW
				serpentinedash.colorized = true
				serpentinedash.blendmode = AST_ADD
				serpentinedash.target = player.mo
				player.mo.local_usedown2 = 1
			end
			if player.mo.serpentine_fire2 > 1
			and not P_PlayerInPain(player)
			and not (P_IsObjectOnGround(player.mo))
			and player.playerstate == PST_LIVE
			and not (player.powers[pw_justsprung] or (player.mo.eflags & MFE_SPRUNG))
			and not player.powers[pw_carry]
				player.mo.serpentine_fire = 0
				player.mo.local_usedown1 = 1
				player.mo.serpentine_fire3 = 0
				player.mo.momz = 0
				if (leveltime & 3) == 1
					player.mo.state = S_PLAY_SERPENTINE_FLYFIRE1
					local fire1 = P_SPMAngle(player.mo, MT_SERPENTINE_FIRE, player.drawangle, 0)
					if fire1 and fire1.valid
						if player.mo.eflags & MFE_VERTICALFLIP
							P_SetObjectMomZ(fire1, 40*FRACUNIT)
							fire1.momx = 12*FRACUNIT
							fire1.momy = 12*FRACUNIT
						else
							P_SetObjectMomZ(fire1, -40*FRACUNIT)
							fire1.momx = -12*FRACUNIT
							fire1.momy = -12*FRACUNIT
						end
					end
				end
				if (leveltime & 5) == 1
					player.mo.state = S_PLAY_SERPENTINE_FLYFIRE4
					local fire2 = P_SPMAngle(player.mo, MT_SERPENTINE_FIRE, player.drawangle, 0)
					if fire2 and fire2.valid
						if player.mo.eflags & MFE_VERTICALFLIP
							P_SetObjectMomZ(fire2, 40*FRACUNIT)
							fire2.momx = -12*FRACUNIT
							fire2.momy = -12*FRACUNIT
						else
							P_SetObjectMomZ(fire2, -40*FRACUNIT)
							fire2.momx = 12*FRACUNIT
							fire2.momy = 12*FRACUNIT
						end
					end
				end
			end
			if player.mo.serpentine_fire2 > 1
			and player.airdodge
				player.mo.serpentine_fire2 = 0
			end
			if player.mo.serpentine_fire3 > 1
			and not P_PlayerInPain(player)
			and player.playerstate == PST_LIVE
			and not (player.powers[pw_justsprung] or (player.mo.eflags & MFE_SPRUNG))
			and not player.powers[pw_carry]
				player.mo.custom1down = 1
				player.mo.momx = 8*$/9
				player.mo.momy = 8*$/9
				player.powers[pw_nocontrol] = 2
				if (leveltime & 3) == 1
					player.mo.state = S_PLAY_SERPENTINE_ULTRA_FIRE1
					local fire1 = P_SPMAngle(player.mo, MT_SERPENTINE_FIRE2, player.drawangle, 0)
					if fire1 and fire1.valid
						if player.mo.eflags & MFE_VERTICALFLIP
							P_SetObjectMomZ(fire1, -40*FRACUNIT)
							fire1.momx = 12*FRACUNIT
							fire1.momy = 12*FRACUNIT
						else
							P_SetObjectMomZ(fire1, 40*FRACUNIT)
							fire1.momx = -12*FRACUNIT
							fire1.momy = -12*FRACUNIT
						end
					end
				end
				if (leveltime & 5) == 1
					player.mo.state = S_PLAY_SERPENTINE_ULTRA_FIRE4
					local fire2 = P_SPMAngle(player.mo, MT_SERPENTINE_FIRE2, player.drawangle, 0)
					if fire2 and fire2.valid
						if player.mo.eflags & MFE_VERTICALFLIP
							P_SetObjectMomZ(fire2, -40*FRACUNIT)
							fire2.momx = -12*FRACUNIT
							fire2.momy = -12*FRACUNIT
						else
							P_SetObjectMomZ(fire2, 40*FRACUNIT)
							fire2.momx = 12*FRACUNIT
							fire2.momy = 12*FRACUNIT
						end
					end
				end
				local serp_shield = P_SpawnMobj(player.mo.x, player.mo.y, player.mo.z, MT_THOK)
				serp_shield.state = S_SERPENTINE_SHIELD
				serp_shield.blendmode = AST_ADD
				serp_shield.angle = player.mo.angle
				serp_shield.fuse = 1
				if (leveltime % 2 == 0)
					serp_shield.frame = A|FF_FULLBRIGHT
				elseif (leveltime % 4 == 0)
					serp_shield.frame = B|FF_FULLBRIGHT
				elseif (leveltime % 5 == 0)
					serp_shield.frame = C|FF_FULLBRIGHT
				elseif (leveltime % 6 == 0)
					serp_shield.frame = D|FF_FULLBRIGHT
				elseif (leveltime % 8 == 0)
					serp_shield.frame = E|FF_FULLBRIGHT
				end
				if player.mo.eflags & MFE_VERTICALFLIP
					serp_shield.eflags = $|MFE_VERTICALFLIP
					P_TeleportMove(serp_shield, serp_shield.x, serp_shield.y, serp_shield.z - FixedMul(12*FRACUNIT, player.mo.scale))
				end
			end
			if player.mo.state == S_PLAY_SERPENTINE_ROCKET4
				S_StartSound(player.mo, sfx_spex2)
				local rocket = P_SpawnPlayerMissile(player.mo, MT_SERPENTINE_ROCKET, MF2_SCATTER)
				if rocket and rocket.valid
					rocket.tracer = player.target
				end
			end
			if player.mo.state == S_PLAY_SERPENTINE_ROCKET1
			or player.mo.state == S_PLAY_SERPENTINE_ROCKET2
			or player.mo.state == S_PLAY_SERPENTINE_ROCKET3
			or player.mo.state == S_PLAY_SERPENTINE_ROCKET4
			or player.mo.state == S_PLAY_SERPENTINE_ROCKET5
			or player.mo.state == S_PLAY_SERPENTINE_ROCKET6
			or player.mo.state == S_PLAY_SERPENTINE_ROCKET7
			or player.mo.state == S_PLAY_SERPENTINE_ROCKET8
			or player.mo.state == S_PLAY_SERPENTINE_ROCKET9
			or player.mo.state == S_PLAY_SERPENTINE_ROCKET10
			or player.mo.state == S_PLAY_SERPENTINE_ROCKET11
				player.powers[pw_nocontrol] = 2
				player.mo.serpentine_rocket = 5
				player.mo.custom1down = 1
			end
			if player.mo.state == S_PLAY_SERPENTINE_FUCK1
			or player.mo.state == S_PLAY_SERPENTINE_FUCK2
			or player.mo.state == S_PLAY_SERPENTINE_FUCK3
			or player.mo.state == S_PLAY_SERPENTINE_DASH1
			or player.mo.state == S_PLAY_SERPENTINE_DASH2
			or player.mo.state == S_PLAY_DASHRUN_SERPENTINE
				player.mo.momz = 0
			end
			if player.mo.serpentine_fire3 == 1
			and not P_PlayerInPain(player)
			and player.playerstate == PST_LIVE
			and not (player.powers[pw_justsprung] or (player.mo.eflags & MFE_SPRUNG))
			and not player.powers[pw_carry]
				player.mo.state = S_PLAY_WALK
				if CBW_Battle
					player.mo.serpentinebattle_cooldown = 50
				end
			end
			if player.mo.serpentine_fire2 == 1
			and not P_PlayerInPain(player)
			and not (P_IsObjectOnGround(player.mo))
			and player.playerstate == PST_LIVE
			and not (player.powers[pw_justsprung] or (player.mo.eflags & MFE_SPRUNG))
			and not player.powers[pw_carry]
				player.mo.state = S_PLAY_SERPENTINE_FUCK1
			end
			if player.mo.serpentine_fire > 1
			and not P_PlayerInPain(player)
			and player.playerstate == PST_LIVE
			and not (player.powers[pw_justsprung] or (player.mo.eflags & MFE_SPRUNG))
			and not player.powers[pw_carry]
				player.mo.local_usedown1 = 1
				player.mo.momx = 8*$/9
				player.mo.momy = 8*$/9
				if (leveltime & 3) == 1
					player.mo.state = S_PLAY_SERPENTINE_FIRE1
					S_StartSound(player.mo, sfx_srpbr)
					local fire3 = P_SPMAngle(player.mo, MT_SERPENTINE_FIRE, player.drawangle, 0)
					P_InstaThrust(fire3, player.mo.angle, 60*FRACUNIT)
					if fire3 and fire3.valid
						if (leveltime % 6) == 1
							P_SetObjectMomZ(fire3, -5*FRACUNIT)
						elseif (leveltime % 8) == 1
							P_SetObjectMomZ(fire3, 5*FRACUNIT)
						else
							fire3.momz = 0
						end
					end
				end
			end
			if player.mo.serpentine_fire == 1
			and not P_PlayerInPain(player)
			and player.playerstate == PST_LIVE
			and not (player.powers[pw_justsprung] or (player.mo.eflags & MFE_SPRUNG))
			and not player.powers[pw_carry]
				if not P_IsObjectOnGround(player.mo)
					if player.powers[pw_justlaunched]
						player.mo.state = S_PLAY_SPRING
					else
						player.mo.state = S_PLAY_FALL
					end
				else
					player.mo.state = S_PLAY_WALK
				end
				if CBW_Battle
					player.mo.serpentinebattle_cooldown = 35
				end
			end
			if player.mo.serpentine_fire > 1
			and not P_PlayerInPain(player)
			and player.playerstate == PST_LIVE
			and not (player.powers[pw_justsprung] or (player.mo.eflags & MFE_SPRUNG))
			and not player.powers[pw_carry]
			and not P_IsObjectOnGround(player.mo)
				if player.powers[pw_justlaunched]
					player.mo.state = S_PLAY_SPRING
				else
					player.mo.state = S_PLAY_FALL
				end
			end
			if not P_IsObjectOnGround(player.mo)
				player.mo.local_usedown1 = 1
				player.mo.serpentine_fire = 0
				player.mo.serpentine_fire3 = 0
				player.mo.custom1down = 1
				player.mo.serpentinedash = 0
			end
			if player.exiting
				if (player.exiting == 99)
					P_PlayVictorySound(player.mo)
				end
			end
			if P_PlayerInPain(player)
			or(CBW_Battle and (player.tumble != nil and player.tumble > 0)) //Tumble Fix
			or player.playerstate == PST_DEAD
			or player.mo.state == S_PLAY_PAIN
			or player.mo.sprite2 == SPR2_PAIN
				player.mo.serpentine_fire = 0
				player.mo.serpentine_fire2 = 0
				player.mo.local_usedown1 = 1
				player.mo.serpentine_fire3 = 0
				player.mo.custom1down = 1
				player.mo.serpentinedash = 0
			end
			if player.mo.serpentine_fire2
			and not P_PlayerInPain(player)
			and (P_IsObjectOnGround(player.mo))
			and player.playerstate == PST_LIVE
			and not (player.powers[pw_justsprung] or (player.mo.eflags & MFE_SPRUNG))
			and not player.powers[pw_carry]
				player.mo.serpentine_fire2 = 0
				player.mo.state = S_PLAY_WALK
			end
			if P_PlayerInPain(player)
				player.mo.serpentine_fire = 0
				player.mo.serpentine_fire2 = 0
				player.mo.local_usedown1 = 1
				player.mo.serpentine_fire3 = 0
				player.mo.custom1down = 1
				player.mo.local_usedown2 = 1
				player.mo.serpentinedash = 0
			end
			if not (player.mo.custom1down)
				player.mo.custom1down = 0
			end
			if not (player.mo.custom2down)
				player.mo.custom2down = 0
			end
			if not (player.cmd.buttons & BT_CUSTOM1)
				player.mo.custom1down = 0
			end
			if not (player.cmd.buttons & BT_CUSTOM2)
				player.mo.custom2down = 0
			end
			if player.mo.state == S_PLAY_STND
			or player.mo.state == S_PLAY_WAIT
			or player.mo.state == S_PLAY_RUN
				if (player.mo.anim_duration > 4)
					player.mo.anim_duration = 4
				end
			end
			//Blaster in Down
			if (player.cmd.buttons & BT_CUSTOM1)
			and not (player.mo.state == S_PLAY_PAIN)
			and player.playerstate == PST_LIVE
			and not player.exiting
			and not player.powers[pw_carry]
			and not (player.pflags & PF_STASIS)
			and not (player.mo.state == S_PLAY_SUPER_TRANS1)
			and not (player.mo.tracer and player.mo.tracer.type == MT_TUBEWAYPOINT)
			and not (player.pflags & PF_SPINNING)
			and player.mo.custom1down == 0
			and P_IsObjectOnGround(player.mo)
			and not player.mo.serpentine_fire2
			and not player.mo.serpentine_fire
			and not player.actionstate
			and not player.guard
			and not player.mo.serpentinebattle_cooldown
				player.mo.custom1down = 1
				S_StartSound(player.mo, sfx_srpbr2)
				player.mo.serpentine_fire3 = 45
				S_StartSound(player.mo, SERP_LAUGH2[P_RandomRange(1, #SERP_LAUGH2)])
			end
			if (player.cmd.buttons & BT_CUSTOM2)
			and not (player.mo.state == S_PLAY_PAIN)
			and player.playerstate == PST_LIVE
			and not player.exiting
			and not player.powers[pw_carry]
			and not (player.pflags & PF_STASIS)
			and not (player.mo.state == S_PLAY_SUPER_TRANS1)
			and not (player.mo.tracer and player.mo.tracer.type == MT_TUBEWAYPOINT)
			and not (player.pflags & PF_SPINNING)
			and player.mo.custom2down == 0
			and P_IsObjectOnGround(player.mo)
			and not player.mo.serpentine_fire2
			and not player.mo.serpentine_fire
			and not player.mo.serpentine_fire3
			and not player.actionstate
			and not player.guard
			and not player.mo.serpentinebattle_cooldown
				player.mo.custom2down = 1
				S_StartSound(player.mo, sfx_spex1)
				S_StartSound(player.mo, SERP_ROCKET[P_RandomRange(1, #SERP_ROCKET)])
				player.mo.state = S_PLAY_SERPENTINE_ROCKET1
				if CBW_Battle
					player.mo.serpentinebattle_cooldown = 65
				end
			end
		end
		if (player.mo and player.mo.valid and player.mo.skin == "serpentine")
			if player.powers[pw_carry]
			or P_PlayerInPain(player)
			or player.exiting
			or player.playerstate == PST_DEAD
				player.mo.serpentine_fire = 0
				player.mo.serpentine_fire2 = 0
				player.mo.local_usedown1 = 1
				player.mo.serpentinedash = 0
			end
			if player.powers[pw_justsprung]
			or (player.mo.eflags & MFE_SPRUNG)
				player.mo.serpentine_fire = 0
				player.mo.serpentine_fire2 = 0
				player.mo.serpentine_fire3 = 0
				player.mo.local_usedown1 = 1
				player.mo.custom1down = 1
				player.mo.local_usedown2 = 1
				player.mo.serpentinedash = 0
			end
			if (player.gotflag or player.gotcrystal)
				player.mo.serpentine_fire = 0
				player.mo.serpentine_fire2 = 0
				player.mo.serpentine_fire3 = 0
				player.mo.local_usedown1 = 1
				player.mo.custom1down = 1
				player.mo.local_usedown2 = 1
				player.mo.serpentinedash = 0
			end
		end
		if player.mo and player.mo.valid and player.mo.skin != "serpentine"
			if player.mo.serpentine_fire
				player.mo.serpentine_fire = nil
			end
			if player.mo.serpentine_fire2
				player.mo.serpentine_fire2 = nil
			end
			if player.mo.serpentine_fire3
				player.mo.serpentine_fire3 = nil
			end
			if player.mo.serpentinedash
				player.mo.serpentinedash = nil
			end
			if player.mo.serpentine_rocket
				player.mo.serpentine_rocket = nil
			end
			if player.mo.serpentinebattle_cooldown
				player.mo.serpentinebattle_cooldown = nil
			end
		end
	end
end)

addHook("PlayerSpawn", function(player)
	if player.mo and player.mo.skin != "serpentine"
	and player.playerstate == PST_LIVE
		player.mo.serpentine_fire = nil
		player.mo.serpentine_fire2 = nil
		player.mo.serpentine_fire3 = nil
		player.mo.serpentinedash = nil
		player.mo.serpentine_rocket = nil
		player.mo.serpentinebattle_cooldown = nil
	end
end)

addHook("SpinSpecial", function(player)
	//Blaster
	if (player.mo and player.mo.valid and player.playerstate == PST_LIVE and player.mo.skin == "serpentine")
	and P_IsObjectOnGround(player.mo)
		if player.exiting
		or player.powers[pw_carry]
		or (player.pflags & PF_STASIS)
		or (player.mo.state == S_PLAY_SUPER_TRANS1)
		or (player.mo.state == S_PLAY_SUPER_TRANS2)
		or (player.mo.state == S_PLAY_SUPER_TRANS3)
		or (player.mo.state == S_PLAY_SUPER_TRANS4)
		or (player.mo.state == S_PLAY_SUPER_TRANS5)
		or (player.mo.state == S_PLAY_SUPER_TRANS6)
		or player.mo.local_usedown1 == 1
		or player.mo.serpentine_fire
		or player.mo.serpentine_fire2
		or player.mo.serpentine_fire3
		or player.mo.serpentinebattle_cooldown
		or player.actionstate
		or player.guard
		or P_PlayerInPain(player)
		and player.playerstate == PST_LIVE
			return
		end
		player.mo.local_usedown1 = 1
		player.mo.serpentine_fire = 1*TICRATE
	end
	//Dash
	if (player.mo and player.mo.valid and player.playerstate == PST_LIVE and player.mo.skin == "serpentine")
	and player.mo.serpentine_fire2 > 1
		if player.exiting
		or player.powers[pw_carry]
		or (player.pflags & PF_STASIS)
		or (player.mo.state == S_PLAY_SUPER_TRANS1)
		or (player.mo.state == S_PLAY_SUPER_TRANS2)
		or (player.mo.state == S_PLAY_SUPER_TRANS3)
		or (player.mo.state == S_PLAY_SUPER_TRANS4)
		or (player.mo.state == S_PLAY_SUPER_TRANS5)
		or (player.mo.state == S_PLAY_SUPER_TRANS6)
		or player.mo.local_usedown2 == 1
		or player.mo.serpentine_fire
		or player.mo.serpentine_fire3
		or player.mo.serpentinedash
		or P_PlayerInPain(player)
		and player.playerstate == PST_LIVE
			return
		end
		player.mo.local_usedown2 = 1
		player.mo.serpentine_fire2 = 0
		player.mo.state = S_PLAY_SERPENTINE_DASH1
		S_StartSound(player.mo, sfx_spin)
	end
end)

local SERP_FLY_ATTACK = {sfx_srp1, sfx_srp4, sfx_none, sfx_none, sfx_none, sfx_srp6, sfx_srp8, sfx_none, sfx_none}

//Momentum
addHook("PlayerThink", function(player)
	if (player.mo and player.mo.valid and player.mo.skin == "serpentine" and player.playerstate == PST_LIVE)
		if (player.cmd.forwardmove or player.cmd.sidemove) and player.normalspeed < player.speed then
			player.mo.friction = FRACUNIT
		else
			player.mo.friction = 29*FRACUNIT/32
		end
	end
end)

//Blaster in Down
addHook("AbilitySpecial", function(player)
	if (player.mo and player.mo.valid and player.mo.skin == "serpentine" and player.playerstate == PST_LIVE)
	and player.charability == CA_NONE
	and not (player.pflags & PF_THOKKED)
	and not (P_IsObjectOnGround(player.mo))
	and not (player.gotflag or player.gotcrystal)
	and not P_PlayerInPain(player)
		player.mo.serpentine_fire2 = 50
		S_StartSound(player.mo, sfx_srpbr2)
		player.pflags = $1|PF_THOKKED
		S_StartSound(player.mo, SERP_FLY_ATTACK[P_RandomRange(1, #SERP_FLY_ATTACK)])
	end
end)